// RemMFC.cpp : AvP[VpNX̒`s܂B
//

#include "stdafx.h"
#include "RemMFC.h"
#include "RemMFCDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CExistApp
CExistApp::CExistApp()
{
	m_hComFile = NULL;
}
//---------------------------------------------------------------------------
CExistApp::~CExistApp()
{
	if( m_hComFile ){
		CloseHandle(m_hComFile);
		m_hComFile = NULL;
	}
}
//---------------------------------------------------------------------------
BOOL CExistApp::IsExist(LPCSTR pKey)
{
	m_hComFile = ::OpenFileMapping(FILE_MAP_ALL_ACCESS, FALSE, pKey);
	if( m_hComFile != NULL ){
		HWND *phWnd = (HWND *)::MapViewOfFile(m_hComFile, FILE_MAP_ALL_ACCESS, 0, 0, 0);
		if( phWnd ){
			HWND hWnd = *phWnd;
			::UnmapViewOfFile(phWnd);
			if( IsWindow(hWnd) ){
				::ShowWindow(hWnd, SW_SHOW);
				::SetForegroundWindow(hWnd);
			}
		}
		return TRUE;
	}
	m_hComFile = (HANDLE)::CreateFileMapping(HANDLE(0xffffffff), NULL, PAGE_READWRITE, 0, sizeof(HWND), pKey);
	if( m_hComFile ){
		HWND *phWnd = (HWND *)::MapViewOfFile(m_hComFile, FILE_MAP_WRITE, 0, 0, 0);
		*phWnd = NULL;
		::UnmapViewOfFile(phWnd);
	}
	return FALSE;
}
//---------------------------------------------------------------------------
void CExistApp::RegisterWindow(HWND hWnd)
{
	if( m_hComFile ){
		HWND *phWnd = (HWND *)::MapViewOfFile(m_hComFile, FILE_MAP_WRITE, 0, 0, 0);
		if( phWnd ){
			*phWnd = hWnd;
			::UnmapViewOfFile(phWnd);
		}
	}
}

/////////////////////////////////////////////////////////////////////////////
// CRemMFCApp

BEGIN_MESSAGE_MAP(CRemMFCApp, CWinApp)
	//{{AFX_MSG_MAP(CRemMFCApp)
		//  - ClassWizard ͂̈ʒuɃ}bsOp̃}Nǉ܂͍폜܂B
		//        ̈ʒuɐR[hҏWȂłB
	//}}AFX_MSG
	ON_COMMAND(ID_HELP, CWinApp::OnHelp)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CRemMFCApp NX̍\z

CRemMFCApp::CRemMFCApp()
{
	m_clBack = RGB(192,192,192);
	m_bHookKeyMessage = TRUE;
}

/////////////////////////////////////////////////////////////////////////////
// B CRemMFCApp IuWFNg

CRemMFCApp theApp;

/////////////////////////////////////////////////////////////////////////////
// CRemMFCApp NX̏

BOOL CRemMFCApp::InitInstance()
{
#ifndef _DEBUG
	if( m_ExistApp.IsExist("RemMFC") ) return FALSE;
#endif

	m_clBack = GetSysColor(COLOR_BTNFACE);
	SetDialogBkColor(m_clBack);

	char IniName[MAX_PATH];
	::GetModuleFileName(m_hInstance, IniName, sizeof(IniName));
	SetEXT(IniName, "ini");
	if( m_pszProfileName ) free(LPVOID(m_pszProfileName));
	m_pszProfileName = _tcsdup(IniName);

	CRemMFCDlg dlg;
	m_pMainWnd = &dlg;
	int nResponse = dlg.DoModal();
	return FALSE;
}

//---------------------------------------------------------------------------
void CRemMFCApp::SetEXT(LPSTR s, LPCSTR pKey)
{
	int len = strlen(s);
	if( !len ) return;
	LPSTR t = s + len - 1;
	for( ; t > s; t-- ){
		if( *t == '.' ){
			t++;
			strcpy(t, pKey);
			return;
		}
	}
	t = s + len - 1;
	*t++ = '.';
	strcpy(t, pKey);
}

BOOL CRemMFCApp::ProcessMessageFilter(int code, LPMSG lpMsg) 
{
	if( m_bHookKeyMessage ){
		// L[bZ[WtbNAtH[JXɊ֌WȂCEChEŏ܂B
		if( lpMsg->message == WM_KEYDOWN ){
			if( (lpMsg->wParam == VK_ESCAPE) || (lpMsg->wParam == VK_F9) ){
				((CRemMFCDlg *)m_pMainWnd)->OnFuncKeyChar(lpMsg->wParam, lpMsg->lParam);
				return TRUE;
			}
			else if( lpMsg->wParam == VK_RETURN ){
				((CRemMFCDlg *)m_pMainWnd)->OnKeyChar(lpMsg->wParam, lpMsg->lParam);
				return TRUE;
			}
		}
		else if( lpMsg->message == WM_CHAR ){
			((CRemMFCDlg *)m_pMainWnd)->OnKeyChar(lpMsg->wParam, lpMsg->lParam);
			return TRUE;
		}
		else if( lpMsg->message == WM_KEYUP ){
			if( (lpMsg->wParam == VK_RETURN) || (lpMsg->wParam == VK_ESCAPE) || (lpMsg->wParam == VK_F9) ){
				return TRUE;
			}
		}
	}
	return CWinApp::ProcessMessageFilter(code, lpMsg);
}
